{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}




unit MainF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, IBServices, ExtCtrls, System.ComponentModel;

type
  TMainForm = class(TForm)
    PageControl1: TPageControl;
    ConfigTab: TTabSheet;
    ShutdownBtn: TButton;
    StartBtn: TButton;
    OpenDbBtn: TButton;
    CloseDbBtn: TButton;
    AsynchRg: TRadioGroup;
    ReadOnlyRg: TRadioGroup;
    ReserveSpaceRg: TRadioGroup;
    SqlDialectRg: TRadioGroup;
    PageBufBtn: TButton;
    SweepBtn: TButton;
    PageBufEdit: TEdit;
    SweepEdit: TEdit;
    BackupTab: TTabSheet;
    BackupBtn: TButton;
    BuMemo: TMemo;
    RestoreBtn: TButton;
    ValidateBtn: TButton;
    StatsTab: TTabSheet;
    StatsBtn: TButton;
    StatsMemo: TMemo;
    LogBtn: TButton;
    SecurityTab: TTabSheet;
    AddUserBtn: TButton;
    FindUserBtn: TButton;
    ModifyUserBtn: TButton;
    DeleteUserBtn: TButton;
    UserNameEdit: TEdit;
    FirstNameEdit: TEdit;
    LastNameEdit: TEdit;
    PasswordEdit: TEdit;
    UserIdEdit: TEdit;
    GroupIdEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    PropertiesTab: TTabSheet;
    PropertiesBtn: TButton;
    PropMemo: TMemo;
    procedure ShutdownBtnClick(Sender: TObject);
    procedure StartBtnClick(Sender: TObject);
    procedure OpenDbBtnClick(Sender: TObject);
    procedure CloseDbBtnClick(Sender: TObject);
    procedure AsynchRgClick(Sender: TObject);
    procedure ReadOnlyRgClick(Sender: TObject);
    procedure ReserveSpaceRgClick(Sender: TObject);
    procedure SqlDialectRgClick(Sender: TObject);
    procedure PageBufBtnClick(Sender: TObject);
    procedure SweepBtnClick(Sender: TObject);
    procedure BackupBtnClick(Sender: TObject);
    procedure RestoreBtnClick(Sender: TObject);
    procedure ValidateBtnClick(Sender: TObject);
    procedure StatsBtnClick(Sender: TObject);
    procedure LogBtnClick(Sender: TObject);
    procedure AddUserBtnClick(Sender: TObject);
    procedure FindUserBtnClick(Sender: TObject);
    procedure ModifyUserBtnClick(Sender: TObject);
    procedure DeleteUserBtnClick(Sender: TObject);
    procedure PropertiesBtnClick(Sender: TObject);
  private
    procedure SetSecurityProperties;
    procedure AfficherAttente;
    procedure StopperAttente;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses MainD, IBHeader;

{$R *.DFM}

procedure TMainForm.AfficherAttente;
begin
  Screen.Cursor := crHourGlass;
end;

procedure TMainForm.StopperAttente;
begin
  Screen.Cursor := crDefault;
end;

procedure TMainForm.ShutdownBtnClick(Sender: TObject);
begin
  with MainDm.IBConfigService do
  begin
    try
      AfficherAttente;
      Active := True;
      ShutdownDatabase(Forced, 0);
      while IsServiceRunning do Sleep(10);
    finally
      Active := False;
      StopperAttente;
    end;
  end;
end;

procedure TMainForm.StartBtnClick(Sender: TObject);
begin
  with MainDm.IBConfigService do
  begin
    try
      AfficherAttente;
      Active := True;
      BringDatabaseOnline;
      while IsServiceRunning do Sleep(10);
    finally
      Active := False;
      StopperAttente;
    end;
  end;
end;

procedure TMainForm.OpenDbBtnClick(Sender: TObject);
begin
  MainDm.EmployeeDb.Open;
end;

procedure TMainForm.CloseDbBtnClick(Sender: TObject);
begin
  MainDm.EmployeeDb.Close;
end;

procedure TMainForm.AsynchRgClick(Sender: TObject);
begin
  with AsynchRg, MainDm.IBConfigService do
  begin
    try
      AfficherAttente;
      Active := True;
      if ItemIndex = 0 then
        SetAsyncMode(True)
      else
        SetAsyncMode(False);
      while IsServiceRunning do Sleep(5);
    finally
      Active := False;
      StopperAttente;
    end;
  end;
end;

procedure TMainForm.ReadOnlyRgClick(Sender: TObject);
begin
  with ReadOnlyRg, MainDm.IBConfigService do
  begin
    try
      AfficherAttente;
      Active := True;
      if ItemIndex = 0 then
        SetReadOnly(True)
      else
        SetReadOnly(False);
      while IsServiceRunning do Sleep(5);
    finally
      Active := False;
      StopperAttente;
    end;
  end;
end;

procedure TMainForm.ReserveSpaceRgClick(Sender: TObject);
begin
  with ReserveSpaceRg, MainDm.IBConfigService do
  begin
    try
      AfficherAttente;
      Active := True;
      if ItemIndex = 0 then
        SetReserveSpace(True)
      else
        SetReserveSpace(False);
      while IsServiceRunning do Sleep(5);
    finally
      Active := False;
      StopperAttente;
    end;
  end;
end;

procedure TMainForm.SqlDialectRgClick(Sender: TObject);
begin
  with SqlDialectRg, MainDm.IBConfigService do
  begin
    try
      AfficherAttente;
      Active := True;
      if ItemIndex = 0 then
        SetDBSqlDialect(1)
      else
        SetDBSqlDialect(3);
      while IsServiceRunning do Sleep(5);
    finally
      Active := False;
      StopperAttente;
    end;
  end;
end;

procedure TMainForm.PageBufBtnClick(Sender: TObject);
begin
  with MainDm.IBConfigService do
  begin
    try
      AfficherAttente;
      Active := True;
      SetPageBuffers(StrToInt(PageBufEdit.Text));
      while IsServiceRunning do Sleep(5);
    finally
      Active := False;
      StopperAttente;
    end;
  end;
end;

procedure TMainForm.SweepBtnClick(Sender: TObject);
begin
  with MainDm.IBConfigService do
  begin
    try
      AfficherAttente;
      Active := True;
      SetSweepInterval(StrToInt(SweepEdit.Text));
      while IsServiceRunning do Sleep(5);
    finally
      Active := False;
      StopperAttente;
    end;
  end;
end;

procedure TMainForm.BackupBtnClick(Sender: TObject);
begin
  with MainDm.IBBackup do
  begin
    BuMemo.Lines.Clear;
    try
      AfficherAttente;
      Active := True;
      ServiceStart;
      while not EOF do
        BuMemo.Lines.Add(GetNextLine);
    finally
      Active := False;
      StopperAttente;
    end;
  end;
end;

procedure TMainForm.RestoreBtnClick(Sender: TObject);
begin
  with MainDm.IBRestore do
  begin
    BuMemo.Lines.Clear;
    try
      AfficherAttente;
      Active := True;
      ServiceStart;
      while not EOF do
        BuMemo.Lines.Add(GetNextLine);
    finally
      Active := False;
      StopperAttente;
    end;
  end;
end;

procedure TMainForm.ValidateBtnClick(Sender: TObject);
begin
  with MainDm.IBValidate do
  begin
    Active := True;
    try
      AfficherAttente;
      ServiceStart;
      while IsServiceRunning do Sleep(10);
      ShowMessage('Validation termine.');
    finally
      Active := False;
      StopperAttente;
    end;
  end;
end;

procedure TMainForm.StatsBtnClick(Sender: TObject);
begin
  with MainDm.IBStat do
  begin
    StatsMemo.Lines.Clear;
    try
      AfficherAttente;
      Active := True;
      ServiceStart;
      while not EOF do
        StatsMemo.Lines.Add(GetNextLine);
    finally
      Active := False;
      StopperAttente;
    end;
  end;
end;

procedure TMainForm.LogBtnClick(Sender: TObject);
begin
  with MainDm.IBLog do
  begin
    StatsMemo.Lines.Clear;
    try
      AfficherAttente;
      Active := True;
      ServiceStart;
      while not EOF do
        StatsMemo.Lines.Add(GetNextLine);
    finally
      Active := False;
      StopperAttente;
    end;
  end;
end;

procedure TMainForm.SetSecurityProperties;
begin
  with MainDm.IBSecurity do
  begin
    UserName := UserNameEdit.Text;
    FirstName := FirstNameEdit.Text;
    LastName := LastNameEdit.Text;
    Password := PasswordEdit.Text;
    UserId := StrToInt(UserIdEdit.Text);
    GroupId := StrToInt(GroupIdEdit.Text);
  end;
end;

procedure TMainForm.AddUserBtnClick(Sender: TObject);
begin
  SetSecurityProperties;
  with MainDm.IBSecurity do
  begin
    Active := True;
    try
      AddUser;
    finally
      Active := False;
    end;
  end;
end;

procedure TMainForm.FindUserBtnClick(Sender: TObject);
begin
  if UserNameEdit.Text = '' then
  begin
    ShowMessage('Vous devez saisir un nom d''utilisateur...');
    Exit;
  end;
  with MainDm.IBSecurity do
  begin
    Active := True;
    try
      DisplayUser(UserNameEdit.Text);
      if UserInfo[0] = nil then
      begin
        ShowMessage('Utilisateur non trouv.');
        Exit;
      end;
      FirstNameEdit.Text := UserInfo[0].FirstName;
      LastNameEdit.Text := UserInfo[0].LastName;
      UserIdEdit.Text := IntToStr(UserInfo[0].UserId);
      GroupIdEdit.Text := IntToStr(UserInfo[0].GroupId);
      PasswordEdit.Text := '';
    finally
      Active := False;
    end;
  end;
end;

procedure TMainForm.ModifyUserBtnClick(Sender: TObject);
begin
  SetSecurityProperties;
  with MainDm.IBSecurity do
  begin
    Active := True;
    try
      ModifyUser;
    finally
      Active := False;
    end;
  end;
end;

procedure TMainForm.DeleteUserBtnClick(Sender: TObject);
begin
  with MainDm.IBSecurity do
  begin
    UserName := UserNameEdit.Text;
    Active := True;
    try
      DeleteUser;
    finally
      Active := False;
    end;
    UserNameEdit.Text := '';
    FirstNameEdit.Text := '';
    LastNameEdit.Text := '';
    PasswordEdit.Text := '';
    UserIdEdit.Text := '0';
    GroupIdEdit.Text := '0';
  end;
end;

procedure TMainForm.PropertiesBtnClick(Sender: TObject);
var
  I:       Integer;
  S:       String;
begin
  with MainDm.IBProperties do
  begin
    PropMemo.Lines.Clear;
    Active := True;
    try
      MainDm.EmployeeDb.Open;
      Options := [Database];
      FetchDatabaseInfo;
      PropMemo.Lines.Add('Nombre d''attachements: ' +
                          IntToStr(DatabaseInfo.NoOfAttachments));
      PropMemo.Lines.Add('Nombre de base de donnes: ' +
                          IntToStr(DatabaseInfo.NoOfDatabases));
      PropMemo.Lines.Add('--------------------------------------------------');
      PropMemo.Lines.Add('Fichiers de la base');
      for I := 0 to High(DatabaseInfo.DbName) do
        PropMemo.Lines.Add(DatabaseInfo.DbName[I]);
      PropMemo.Lines.Add('--------------------------------------------------');
      MainDm.EmployeeDb.Close;
      Options := [ConfigParameters];
      FetchConfigParams;
      PropMemo.Lines.Add('Rpertoire de base: ' + ConfigParams.BaseLocation);
      PropMemo.Lines.Add('Rpertoire des locks: ' + ConfigParams.LockFileLocation);
      PropMemo.Lines.Add('Rpertoire des messages: ' + ConfigParams.MessageFileLocation);
      PropMemo.Lines.Add('Base de scurit: ' +
        ConfigParams.SecurityDatabaseLocation);
      PropMemo.Lines.Add('--------------------------------------------------');
      for I := 0 to High(ConfigParams.ConfigFileData.ConfigFileValue) do
      begin
        case ConfigParams.ConfigFileData.ConfigFileKey[I] of
          ISCCFG_LOCKMEM_KEY:         S := 'LockMem';
          ISCCFG_LOCKSEM_KEY:         S := 'LockSem';
          ISCCFG_LOCKSIG_KEY:         S := 'LockSig';
          ISCCFG_EVNTMEM_KEY:         S := 'EventMem';
          ISCCFG_DBCACHE_KEY:         S := 'DbCache';
          ISCCFG_PRIORITY_KEY:        S := 'Priority';
          ISCCFG_IPCMAP_KEY:          S := 'IPCMap';
          ISCCFG_MEMMIN_KEY:          S := 'MemMin';
          ISCCFG_MEMMAX_KEY:          S := 'MemMax';
          ISCCFG_LOCKORDER_KEY:       S := 'LockOrder';
          ISCCFG_ANYLOCKMEM_KEY:      S := 'AnyLockMem';
          ISCCFG_ANYLOCKSEM_KEY:      S := 'AnyLockSem';
          ISCCFG_ANYLOCKSIG_KEY:      S := 'AnyLockSig';
          ISCCFG_ANYEVNTMEM_KEY:      S := 'AnyEventMem';
          ISCCFG_LOCKHASH_KEY:        S := 'LockHash';
          ISCCFG_DEADLOCK_KEY:        S := 'Deadlock';
          ISCCFG_LOCKSPIN_KEY:        S := 'LockSpin';
          ISCCFG_CONN_TIMEOUT_KEY:    S := 'Conn Timout';
          ISCCFG_DUMMY_INTRVL_KEY:    S := 'Dummy Interval';
        end;
        PropMemo.Lines.Add(S + ': ' +
          IntToStr(ConfigParams.ConfigFileData.ConfigFileValue[I]));
      end;
      PropMemo.Lines.Add('--------------------------------------------------');
      Options := [Version];
      FetchVersionInfo;
      PropMemo.Lines.Add('Version du serveur: ' + VersionInfo.ServerVersion);
      PropMemo.Lines.Add('Implmentation serveur: ' +
        VersionInfo.ServerImplementation);
      PropMemo.LInes.Add('Version de service: ' +
        IntToStr(VersionInfo.ServiceVersion));
    finally
      Active := False;
    end;
  end;
end;

end.
