{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}

unit Unit2;

interface

uses
  Classes, IBSQL;

type
  TTestthread = class(TThread)
  private
    { Private declarations }
  protected
    sql : TIBSQL;
    procedure Execute; override;

  end;

implementation

uses IBDatabase, Unit1, Windows;
{ Important: Methods and properties of objects in VCL or CLX can only be used
  in a method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure TTestthread.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ TTestthread }

procedure TTestthread.Execute;
var
  d : TIBDatabase;
begin
  d := nil;
  sql := TIBSQL.Create(nil);
  { Place thread code here }
  while not Terminated do
  begin
    while not Assigned(d) do
      d := Form1.IBConnectionBroker1.GetConnection;

    // Always update teh IBX component's Database and Transaction properties
    // with the new pooled DB.

    sql.Database := d;
    sql.Transaction := d.DefaultTransaction;
    sql.Transaction.StartTransaction;
    sql.SQL.Text := 'select * from employee';
    sql.ExecQuery;
    while not sql.Eof do
      sql.Next;
    Sleep(1000 + Random(5000));
    sql.Close;
    sql.SQL.Text := 'select * from customer';
    sql.ExecQuery;
    while not sql.Eof do
      sql.Next;
    sql.Close;
    sql.Transaction.Commit;

    sql.FreeHandle;
    Form1.IBConnectionBroker1.ReleaseConnection(d);
    d := nil;
    Sleep(1000 + Random(1000));
  end;
  sql.Free;
end;

end.
